#include "IRremote.h"

/****************************************************************************************************/
/*              Projet:   Manette de jeu infrarouge avec Arduino 2/2                                */
/*              Lien:     https://www.electronique-mixte.fr/manette-de-jeu-infrarouge-avec-arduino/ */
/*              YouTube:  https://www.youtube.com/electroniquemixte/?sub_confirmation=1             */
/****************************************************************************************************/

// Numéro du pin sortie du récepteur 
long int res_val;
const int receiver = 11; 

// Indicateurs manette  
const int UpLED = 2;
const int DownLED  = 3;
const int LeftLED  = 4;
const int RightLED  = 5;

// Déclaration d'un objet IRrecv
IRrecv irrecv(receiver);           
decode_results results;            

void setup()  
{
  // Init RS232
  Serial.begin(9600);
  
  // Init Indicateurs manette   
  pinMode(UpLED, OUTPUT);
  pinMode(DownLED, OUTPUT);
  pinMode(LeftLED, OUTPUT);
  pinMode(RightLED, OUTPUT);
  
  // Init du récepteur 
  irrecv.enableIRIn();
  
  // Initialisation 
  digitalWrite(UpLED, LOW);   
  digitalWrite(DownLED, LOW);                                        
  digitalWrite(LeftLED, LOW); 
  digitalWrite(RightLED, LOW); 
}

void loop()  
{
  // Lecture de la télécommande 
  if (irrecv.decode(&results))
  {
    // Récupération du code   
    res_val = results.value;

    // Réception de la nouvelle valeur
    irrecv.resume();
  } 

  // Envoie la commande à Matlab  
  ManetteTocuhe(res_val); 

  // Init 
  res_val=0; 
}

void InitLEDs(void)
{
  digitalWrite(UpLED, LOW);   
  digitalWrite(DownLED, LOW);                                        
  digitalWrite(LeftLED, LOW); 
  digitalWrite(RightLED, LOW);
  Serial.println(99,DEC); // Waiting... 
  delay(200);  
}
void ManetteTocuhe(long Chan_code)
{
  switch(res_val)  
  {
    case 0xFF18E7: // Up
      digitalWrite(UpLED, HIGH);   
      digitalWrite(DownLED, LOW);                                        
      digitalWrite(LeftLED, LOW); 
      digitalWrite(RightLED, LOW);
      Serial.println(150,DEC); 
      delay(200);
      break;

    case 0xFF4AB5: // Down
      digitalWrite(UpLED, LOW);   
      digitalWrite(DownLED, HIGH);                                        
      digitalWrite(LeftLED, LOW); 
      digitalWrite(RightLED, LOW); 
      Serial.println(160,DEC);
      delay(200); 
      break;
      
    case 0xFF10EF: // Left
      digitalWrite(UpLED, LOW);   
      digitalWrite(DownLED, LOW);                                        
      digitalWrite(LeftLED, HIGH); 
      digitalWrite(RightLED, LOW); 
      Serial.println(170,DEC);
      delay(200); 
      break;
      
    case 0xFF5AA5: // Right
      digitalWrite(UpLED, LOW);   
      digitalWrite(DownLED, LOW);                                        
      digitalWrite(LeftLED, LOW); 
      digitalWrite(RightLED, HIGH); 
      Serial.println(180,DEC);
      delay(200); 
      break;
    
    default:
      InitLEDs(); 
  }
}
